// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from tuw_multi_robot_msgs:srv/StationManagerStationProtocol.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "tuw_multi_robot_msgs/srv/station_manager_station_protocol.h"


#ifndef TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_STATION_PROTOCOL__FUNCTIONS_H_
#define TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_STATION_PROTOCOL__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/action_type_support_struct.h"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_runtime_c/service_type_support_struct.h"
#include "rosidl_runtime_c/type_description/type_description__struct.h"
#include "rosidl_runtime_c/type_description/type_source__struct.h"
#include "rosidl_runtime_c/type_hash.h"
#include "rosidl_runtime_c/visibility_control.h"
#include "tuw_multi_robot_msgs/msg/rosidl_generator_c__visibility_control.h"

#include "tuw_multi_robot_msgs/srv/detail/station_manager_station_protocol__struct.h"

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_type_hash_t *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol__get_type_hash(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeDescription *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol__get_type_description(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol__get_individual_type_description_source(
  const rosidl_service_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol__get_type_description_sources(
  const rosidl_service_type_support_t * type_support);

/// Initialize srv/StationManagerStationProtocol message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request
 * )) before or use
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * msg);

/// Finalize srv/StationManagerStationProtocol message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * msg);

/// Create srv/StationManagerStationProtocol message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__create(void);

/// Destroy srv/StationManagerStationProtocol message.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * msg);

/// Check for srv/StationManagerStationProtocol message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * rhs);

/// Copy a srv/StationManagerStationProtocol message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_type_hash_t *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeDescription *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * array, size_t size);

/// Finalize array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * array);

/// Create array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the array and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__create(size_t size);

/// Destroy array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * array);

/// Check for srv/StationManagerStationProtocol message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * rhs);

/// Copy an array of srv/StationManagerStationProtocol messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Request__Sequence * output);

/// Initialize srv/StationManagerStationProtocol message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response
 * )) before or use
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * msg);

/// Finalize srv/StationManagerStationProtocol message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * msg);

/// Create srv/StationManagerStationProtocol message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__create(void);

/// Destroy srv/StationManagerStationProtocol message.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * msg);

/// Check for srv/StationManagerStationProtocol message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * rhs);

/// Copy a srv/StationManagerStationProtocol message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_type_hash_t *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeDescription *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * array, size_t size);

/// Finalize array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * array);

/// Create array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the array and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__create(size_t size);

/// Destroy array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * array);

/// Check for srv/StationManagerStationProtocol message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * rhs);

/// Copy an array of srv/StationManagerStationProtocol messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Response__Sequence * output);

/// Initialize srv/StationManagerStationProtocol message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event
 * )) before or use
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * msg);

/// Finalize srv/StationManagerStationProtocol message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * msg);

/// Create srv/StationManagerStationProtocol message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__create(void);

/// Destroy srv/StationManagerStationProtocol message.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * msg);

/// Check for srv/StationManagerStationProtocol message equality.
/**
 * \param[in] lhs The message on the left hand size of the equality operator.
 * \param[in] rhs The message on the right hand size of the equality operator.
 * \return true if messages are equal, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * rhs);

/// Copy a srv/StationManagerStationProtocol message.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source message pointer.
 * \param[out] output The target message pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer is null
 *   or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event * output);

/// Retrieve pointer to the hash of the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_type_hash_t *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__get_type_hash(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeDescription *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__get_type_description(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the single raw source text that defined this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support);

/// Retrieve pointer to the recursive raw sources that defined the description of this type.
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_runtime_c__type_description__TypeSource__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__get_type_description_sources(
  const rosidl_message_type_support_t * type_support);

/// Initialize array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the number of elements and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__init(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * array, size_t size);

/// Finalize array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__fini(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * array);

/// Create array of srv/StationManagerStationProtocol messages.
/**
 * It allocates the memory for the array and calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence *
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__create(size_t size);

/// Destroy array of srv/StationManagerStationProtocol messages.
/**
 * It calls
 * tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
void
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__destroy(tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * array);

/// Check for srv/StationManagerStationProtocol message array equality.
/**
 * \param[in] lhs The message array on the left hand size of the equality operator.
 * \param[in] rhs The message array on the right hand size of the equality operator.
 * \return true if message arrays are equal in size and content, otherwise false.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__are_equal(const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * lhs, const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * rhs);

/// Copy an array of srv/StationManagerStationProtocol messages.
/**
 * This functions performs a deep copy, as opposed to the shallow copy that
 * plain assignment yields.
 *
 * \param[in] input The source array pointer.
 * \param[out] output The target array pointer, which must
 *   have been initialized before calling this function.
 * \return true if successful, or false if either pointer
 *   is null or memory allocation fails.
 */
ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
bool
tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence__copy(
  const tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * input,
  tuw_multi_robot_msgs__srv__StationManagerStationProtocol_Event__Sequence * output);
#ifdef __cplusplus
}
#endif

#endif  // TUW_MULTI_ROBOT_MSGS__SRV__DETAIL__STATION_MANAGER_STATION_PROTOCOL__FUNCTIONS_H_
