// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from tuw_multi_robot_msgs:msg/RoutePrecondition.idl
// generated code does not contain a copyright notice

#include "tuw_multi_robot_msgs/msg/detail/route_precondition__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_tuw_multi_robot_msgs
const rosidl_type_hash_t *
tuw_multi_robot_msgs__msg__RoutePrecondition__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x41, 0xbd, 0xfb, 0x89, 0x37, 0xe6, 0x25, 0xe3,
      0x8b, 0x24, 0x60, 0xd4, 0x92, 0x80, 0x4b, 0x16,
      0x34, 0x4e, 0xfd, 0xc7, 0x97, 0xf8, 0x48, 0xc9,
      0xca, 0x15, 0x9b, 0xa3, 0x4e, 0x94, 0xbd, 0xbc,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char tuw_multi_robot_msgs__msg__RoutePrecondition__TYPE_NAME[] = "tuw_multi_robot_msgs/msg/RoutePrecondition";

// Define type names, field names, and default values
static char tuw_multi_robot_msgs__msg__RoutePrecondition__FIELD_NAME__robot_id[] = "robot_id";
static char tuw_multi_robot_msgs__msg__RoutePrecondition__FIELD_NAME__current_route_segment[] = "current_route_segment";

static rosidl_runtime_c__type_description__Field tuw_multi_robot_msgs__msg__RoutePrecondition__FIELDS[] = {
  {
    {tuw_multi_robot_msgs__msg__RoutePrecondition__FIELD_NAME__robot_id, 8, 8},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_STRING,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {tuw_multi_robot_msgs__msg__RoutePrecondition__FIELD_NAME__current_route_segment, 21, 21},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
tuw_multi_robot_msgs__msg__RoutePrecondition__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {tuw_multi_robot_msgs__msg__RoutePrecondition__TYPE_NAME, 42, 42},
      {tuw_multi_robot_msgs__msg__RoutePrecondition__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "#################################################################\n"
  "## Route Preconditions are used to sync robots on a route\n"
  "## e.g.: Each robot publishes its current step of its route\n"
  "## with such a message\n"
  "## The specific segments of a route are marked with such\n"
  "## preconditions to block a robot from entering a segment\n"
  "## until the sync message of the other robot has the right\n"
  "## route_segment_nr\n"
  "#################################################################\n"
  "\n"
  "string robot_id                  # the robot name for the precondition\n"
  "int32 current_route_segment      # the segment nr of the route executed by the given robot";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
tuw_multi_robot_msgs__msg__RoutePrecondition__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {tuw_multi_robot_msgs__msg__RoutePrecondition__TYPE_NAME, 42, 42},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 629, 629},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
tuw_multi_robot_msgs__msg__RoutePrecondition__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *tuw_multi_robot_msgs__msg__RoutePrecondition__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
